<?php
/*
Plugin Name: Status Widget
Plugin URI: http://www.h-fj.com/blog/wpplgdoc/copyrightwidget.php
Description: 最終更新日／投稿数／コメント数を表示します
Author: Hajime Fujimoto
Version: 1.0
Author URI: http://www.h-fj.com/blog/
*/

class WP_Widget_Status extends WP_Widget {
	function WP_Widget_Status() {
		$widget_ops = array(
			// ウィジェットを囲む要素に割り当てるクラス名
			'classname' => 'widget_status',
			// ウィジェットの説明
			'description' => '最終更新日／投稿数／コメント数の表示'
		);
		// ウィジェットのID／名前／オプションを初期化
		$this->WP_Widget('status', 'ステータス', $widget_ops);
	}

	function form($instance) {
        // 「title」の設定からHTMLのタグを除いて$titleに代入
		$title = strip_tags($instance['title']);
		// 設定用のフォームを出力
?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>">タイトル</label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" />
		</p>
<?php
	}

	function update($new_instance, $old_instance) {
		// $instanceに元の設定値($old_instance)を代入
		$instance = $old_instance;
		// 「title」の設定値を更新
		$instance['title'] = strip_tags($new_instance['title']);
		// $instanceを返す
		return $instance;
	}

	function widget($args, $instance) {
		// $before_widgetなどの変数を取り出す
		extract($args);
		// ウィジェットのタイトルにフィルタをかけてから$titleに代入
		$title = apply_filters('widget_title', empty($instance['title']) ? 'ステータス' : $instance['title']);
		// ウィジェットの前に表示する内容を出力
		echo $before_widget;
		// タイトルを出力
		if ($title) {
			echo $before_title . $title . $after_title;
		}
		// 最新の投稿の日付を得る
		global $wpdb, $post;
		$posts = get_posts("numberposts=1&orderby=date&order=DESC");
		$post = $posts[0];
		setup_postdata($post);
		$post_date = get_the_time('Y年m月d日');
		// 全投稿数を得る
		$post_count = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'publish' AND post_type = 'post'");
		// 全コメント数を得る
		$comment_count = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->comments WHERE comment_approved = '1'");
		// ウィジェットの内容を出力
?>
		<ul>
		<li>最終更新日: <?php echo $post_date; ?></li>
		<li>投稿数：<?php echo $post_count; ?></li>
		<li>コメント数：<?php echo $comment_count; ?></li>
		</ul>
<?php
		// ウィジェットの後に表示する内容を出力
		echo $after_widget;
	}
}

// ウィジェットを登録
add_action('widgets_init', create_function('', 'return register_widget("WP_Widget_Status");'));
?>
